routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\DiscussionController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [DiscussionController::class, 'index'])->name('home');


//============================Routes for discussions middleware in controller constructor
Route::resource('discussions', DiscussionController::class);

//============================Routes for approving
Route::middleware('adminApprove')->group(function () {
    Route::get('/approve', [DiscussionController::class, 'notApproved'])->name('discussions.notapproved');
    Route::get('/notapproved', [DiscussionController::class, 'renderNotApproved']);
    Route::get('/approved', [DiscussionController::class, 'renderApproved'])->name('discussions.approve');


    Route::put('/approve/{discussion}', [DiscussionController::class, 'approve'])->name('approve.store');
});

//============================Routes for comments 
Route::resource('comments', CommentController::class)->middleware('auth');
Route::get('/comments/create/{discussion}', [CommentController::class, 'create'])->name('comments.createCustom')->middleware('auth');

require __DIR__ . '/auth.php';

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Styles -->
        <script src="https://cdn.tailwindcss.com"></script>
        <link rel="stylesheet" href="{{ asset('css/app.css') }}">

        <!-- Scripts -->

        {{-- jQuery --}}
        <script
        src="https://code.jquery.com/jquery-3.6.0.js"
        integrity="sha256-H+K7U5CnXl1h5ywQfKtSj8PCmoN9aaq30gDh27Xc0jk="
        crossorigin="anonymous"></script>

        {{-- sweetalert cdn --}}
        <script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>

        {{-- delete popup for comments --}}
        @if (Route::is('discussions.show'))
        <script src="{{ asset('js/comments/deletePopup.js') }}" defer></script>
        <script src="{{ asset('js/comments/commentCreate.js') }}" defer></script>
        <script src="{{ asset('js/comments/commentEdit.js') }}" defer></script>
        @endif

        {{-- AJAX for approved --}}
        @if (Route::is('discussions.notapproved'))
        <script src="{{ asset('js/discussions/approveAjax.js') }}" defer></script>            
        <script src="{{ asset('js/discussions/discussionDeleteAjax.js') }}" defer></script>            
        <script src="{{ asset('js/discussions/discussionApproveAjax.js') }}" defer></script>            
        @endif


        <script src="{{ asset('js/app.js') }}" defer></script>


    </head>
    <body class="font-sans antialiased">
        <div class="min-h-screen bg-gray-100">
            @include('layouts.navigation')

            <!-- Page Heading -->
            <header class="">
                <div class="max-w-7xl mx-auto py-6 px-4 sm:px-6 lg:px-8">
                    {{ $header }}
                </div>
            </header>

            <!-- Page Content -->
            <main>
                {{ $slot }}
            </main>
        </div>
    </body>
</html>

resources/views/layouts/backButton.blade.php
<div class="py-12">
    <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        @php
            if (!isset($param))
                $param = '';
        @endphp
        <a class="py-2 px-6 font-semibold rounded-md bg-gray-500 hover:bg-gray-700 text-white" href="{{ route($route, $param) }}">
                Go back            
        </a>
    </div>
</div>

resources/views/layouts/comment.blade.php
<div class="py-3 comment">
    <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
           
            <div class="p-6 bg-white border-b border-gray-200">
                
                <div class="flex items-center justify-between text-sm text-gray-500">                            
                    <span class="font-semibold">{{ $comment->user->username }} says:</span>     
                        
                    <span class="updatedAt">{{ $comment->updated_at }}</span>
                </div>

                <div class="ml-3 mt-3 flex justify-center flex-col">                             
                    <p> {{$comment->text }}</p>
                    <div class="ml-auto flex items-center text-sm text-gray-500"> 
                        @auth
                            @if (Auth::id() == $comment->user_id || Auth::user()->isAdmin())                                   
                            <div class="flex item-center justify-center">
                                
                                <a id="show_comment_edit" href="{{route('comments.edit', $comment->id)}}">
                                    <div class="w-5 mr-2 transform hover:text-purple-500 hover:scale-110">
                                        <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                            <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M15.232 5.232l3.536 3.536m-2.036-5.036a2.5 2.5 0 113.536 3.536L6.5 21.036H3v-3.572L16.732 3.732z" />
                                        </svg>
                                    </div>
                                </a>                                 
                                <a href="{{route('comments.destroy', $comment->id)}}" class="show_confirm" data-toggle="tooltip" title='Delete'>
                                    <div class="w-5 mr-2 transform hover:text-purple-500 hover:scale-110">
                                        <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                            <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M19 7l-.867 12.142A2 2 0 0116.138 21H7.862a2 2 0 01-1.995-1.858L5 7m5 4v6m4-6v6m1-10V4a1 1 0 00-1-1h-4a1 1 0 00-1 1v3M4 7h16" />
                                        </svg>
                                    </div>
                                </a>
                            </div>
                            @endif
                        @endauth
                        
                    </div>
                </div>
               
            </div>
        
        </div>
    </div>
</div>

resources/views/layouts/discussions.blade.php
<span id="typeOfDiscussions"
data-type='@php
if(isset($approved)){
    if($approved){
        echo 'approvedDiscussions';
    }
}    else{
        echo 'notApprovedDiscussions';
    }
@endphp'>
</span>
@if ($discussions->isEmpty())
<h2 class="font-semibold text-xl text-gray-500 leading-tight text-center">
    Nothing here yet!
 </h2>    
@endif
@foreach ($discussions as $discussion)
<div class="py-3 discussion">
    <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
            <div class="p-6 bg-white border-b border-gray-200 flex">
                <div class="md:shrink-0">
                    <img class="h-48 object-cover md:w-48" src="{{ $discussion->image }}" alt="discussionImage">
                </div>
                <div class="ml-3 flex justify-center flex-col"> 
                    <h4 class="font-semibold">
                        {{ $discussion->title }}
                    </h4>
                    <p> {{ $discussion->description }} </p>
                </div>
                <div class="ml-auto flex items-center text-sm text-gray-500"> 

                    @auth
                        @if (Auth::user()->isAdmin())
                                                          
                        <div class="flex item-center justify-center">

                        @if(!$discussion->is_approved)                                                               
                            <a href="{{route('approve.store', $discussion->id)}}" class="show_approve" data-toggle="tooltip" title='Approve'>
                                <div class="w-5 mr-2 transform hover:text-purple-500 hover:scale-110">
                                    <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                        <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M20.285 2l-11.285 11.567-5.286-5.011-3.714 3.716 9 8.728 15-15.285z" />
                                        <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M20.285 2l-11.285 11.567-5.286-5.011-3.714 3.716 9 8.728 15-15.285z" />
                                    </svg>
                                </div>
                            </a>
                        @endif                           
                            
                            <a href="{{route('discussions.edit', $discussion->id)}}">
                                <div class="w-5 mr-2 transform hover:text-purple-500 hover:scale-110">
                                    <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                        <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M15.232 5.232l3.536 3.536m-2.036-5.036a2.5 2.5 0 113.536 3.536L6.5 21.036H3v-3.572L16.732 3.732z" />
                                    </svg>
                                </div>
                            </a>                                    
                            <a href="{{route('discussions.destroy', $discussion->id)}}" class="show_confirm" data-toggle="tooltip" title='Delete'>
                                <div class="w-5 mr-2 transform hover:text-purple-500 hover:scale-110">
                                    <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                        <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M19 7l-.867 12.142A2 2 0 0116.138 21H7.862a2 2 0 01-1.995-1.858L5 7m5 4v6m4-6v6m1-10V4a1 1 0 00-1-1h-4a1 1 0 00-1 1v3M4 7h16" />
                                    </svg>
                                </div>
                            </a>
                        </div>
                        @endif
                    @endauth
                    <span>{{ $discussion->category->name }} | {{ $discussion->user->username }}</span>
                </div>
            </div>
        </div>
    </div>
</div>
@endforeach

<div class="p-3">
    <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        <div id="myPagination" class="p-3 overflow-hidden  sm:rounded-lg">
            {{ $discussions->render() }}
        </div>
    </div>
</div>

resources/views/layouts/guest.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Styles -->
        <script src="https://cdn.tailwindcss.com"></script>
        <link rel="stylesheet" href="{{ asset('css/app.css') }}">

        <!-- Scripts -->
        <script src="{{ asset('js/app.js') }}" defer></script>
    </head>
    <body>
        <div class="font-sans text-gray-900 antialiased">
            {{ $slot }}
        </div>
    </body>
</html>

resources/views/layouts/navigation.blade.php
<nav x-data="{ open: false }" class="bg-white border-b border-gray-100">
    <!-- Primary Navigation Menu -->
    <div class="max-w-7xl mx-auto px-4 sm:px-6 lg:px-8">
        <div class="flex justify-between h-16">
            <div class="flex">
                <!-- Logo -->
                <div class="shrink-0 flex items-center">
                    <a href="{{ route('home') }}">
                        <x-application-logo class="block h-10 w-auto fill-current text-gray-600" />
                        <span class="font-semibold text-gray-600 hover:text-gray-800">Laravel</span>                         
                    </a>
                </div>
                
            </div>
            
            <!-- Settings Dropdown -->
            @if (Auth::check())
            <div class="hidden sm:flex sm:items-center sm:ml-6">
                <x-dropdown align="right" width="48">
                    <x-slot name="trigger">
                        <button class="flex items-center text-sm font-medium text-gray-500 hover:text-gray-700 hover:border-gray-300 focus:outline-none focus:text-gray-700 focus:border-gray-300 transition duration-150 ease-in-out">
                            
                                <div>{{ Auth::user()->username }}</div>
                                <div class="ml-1">
                                    <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20">
                                        <path fill-rule="evenodd" d="M5.293 7.293a1 1 0 011.414 0L10 10.586l3.293-3.293a1 1 0 111.414 1.414l-4 4a1 1 0 01-1.414 0l-4-4a1 1 0 010-1.414z" clip-rule="evenodd" />
                                    </svg>
                                </div>
                            
                                                              
                                
                            </button>
                    </x-slot>
                    
                    <x-slot name="content">
                        <!-- Authentication -->
                        <form method="POST" action="{{ route('logout') }}">
                            @csrf
                            
                            <x-dropdown-link :href="route('logout')"
                            onclick="event.preventDefault();
                                                this.closest('form').submit();">
                                {{ __('Log Out') }}
                            </x-dropdown-link>
                        </form>
                    </x-slot>
                </x-dropdown>
            </div>

            @else
            <div class="hidden space-x-8 sm:-my-px sm:ml-10 sm:flex">
                <x-nav-link :href="route('login')">
                    {{ __('Log In') }}
                </x-nav-link>
                <x-nav-link :href="route('register')">
                    {{ __('Register') }}
                </x-nav-link>  
            </div>
            @endif

            <!-- Hamburger -->
            <div class="-mr-2 flex items-center sm:hidden">
                <button @click="open = ! open" class="inline-flex items-center justify-center p-2 rounded-md text-gray-400 hover:text-gray-500 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 focus:text-gray-500 transition duration-150 ease-in-out">
                    <svg class="h-6 w-6" stroke="currentColor" fill="none" viewBox="0 0 24 24">
                        <path :class="{'hidden': open, 'inline-flex': ! open }" class="inline-flex" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M4 6h16M4 12h16M4 18h16" />
                        <path :class="{'hidden': ! open, 'inline-flex': open }" class="hidden" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M6 18L18 6M6 6l12 12" />
                    </svg>
                </button>
            </div>
        </div>
    </div>

    <!-- Responsive Navigation Menu -->
    <div :class="{'block': open, 'hidden': ! open}" class="hidden sm:hidden">
        
        <!-- Responsive Settings Options -->
        @if (Auth::check())
        <div class="pt-4 pb-1 border-t border-gray-200">
            <div class="px-4">
                <div>{{ Auth::user()->username }}</div>                                         
            </div>
            
            <div class="mt-3 space-y-1">
                <!-- Authentication -->
                <form method="POST" action="{{ route('logout') }}">
                    @csrf

                    <x-responsive-nav-link :href="route('logout')"
                    onclick="event.preventDefault();
                                        this.closest('form').submit();">
                        {{ __('Log Out') }}
                    </x-responsive-nav-link>
                </form>
            </div>
        </div>
        @else
        <div class="pt-2 pb-3 space-y-1">
            <x-responsive-nav-link :href="route('login')">
                {{ __('Log In') }}
            </x-responsive-nav-link>
        </div>
        <div class="pt-2 pb-3 space-y-1">
            <x-responsive-nav-link :href="route('register')">
                {{ __('Register') }}
            </x-responsive-nav-link> 
        </div>
        
                            
        @endif
    </div>
</nav>

resources/views/layouts/sessionAlert.blade.php
@if(Session::has('error'))
    <div class="flex items-center justify-center">
        <div class="bg-red-100 border border-red-400 text-red-700 w-1/2 text-center px-4 py-3 mb-5 rounded" role="alert">
            {{ Session::get('error') }}
        </div>
    </div>
    @endif

    @if(Session::has('success'))
    <div class="flex items-center justify-center">
        <div class="bg-green-100 border border-green-400 text-green-700 w-1/2 text-center px-4 py-3 mb-5 rounded" role="alert">
            {{ Session::get('success') }}
        </div>
    </div>
@endif